#include <windows.h>
#include <stdio.h>
#include "q_shared.h"
#include "tr_types.h"
#include "cg_public.h"
#include "wrapper.h"
#include "main.h"

const char *CG_Argv( int arg ) {
        static char     buffer[MAX_STRING_CHARS];

        syscall(CG_ARGV, arg, buffer, sizeof( buffer ) );

        return buffer;
}
void Wrap_function(void) {
	syscall(CG_PRINT,"Wrapper function was called\n");
}

// our local cvar table and related functions
vmCvar_t wrap_test;
vmCvar_t wrapper;

typedef struct {
        vmCvar_t        *vmCvar;
        char            *cvarName;
        char            *defaultString;
        int                     cvarFlags;
} cvarTable_t;


cvarTable_t cvarTable[] = {
        { &wrap_test, "wrap_test", "0", 0 },
		{ &wrapper, "wrapper", "0", CVAR_ARCHIVE }
};

int	cvarTableSize = sizeof( cvarTable ) / sizeof( cvarTable[0] );

// register cvars with the quake3 exec
void RegisterCvars( void ) {
    int i;
    cvarTable_t *cv;
        
	for ( i = 0, cv = cvarTable ; i < cvarTableSize ; i++, cv++ ) {
		syscall(CG_CVAR_REGISTER, cv->vmCvar, cv->cvarName, cv->defaultString, cv->cvarFlags );
	} 
}       
        
// call this to update cvar values from the quake3 exec
void UpdateCvars( void ) {
	int i;
    cvarTable_t *cv;
        
    for ( i = 0, cv = cvarTable ; i < cvarTableSize ; i++, cv++ ) {
		syscall(CG_CVAR_UPDATE, cv->vmCvar );
    }
}


// our local console command table a related functions.
typedef struct {
        char    *cmd;
        void    (*function)(void);
} consoleCommand_t;

static consoleCommand_t commands[] = {
	{ "wrap_function", Wrap_function },
};

int commandTableSize = sizeof(commands) / sizeof(commands[0]);

// register console commands into the quake3 exec
void RegisterConsoleCmd(void) {
	int i;
	consoleCommand_t *cc;

	for(i = 0,cc = commands;i < commandTableSize;i++,cc++) {
		syscall(CG_ADDCOMMAND,cc->cmd);
	}

}

// see if the console command it one of ours and exec the function related to it
qboolean ConsoleCommand(void) {
	const char      *cmd;
    int             i;
        
    cmd = CG_Argv(0);
	for ( i = 0 ; i < sizeof( commands ) / sizeof( commands[0] ) ; i++ ) {
		if ( !strcmp( cmd, commands[i].cmd ) ) {
			commands[i].function();
			return qtrue; 
        }
    }
	return qfalse;
}

