
// cgamex86_wrapper by ackmed <ackmed@gotwalls.com>
// 09/29/2000

#include <windows.h>
#include <stdio.h>
#include <stdarg.h>

#include "q_shared.h"
#include "tr_types.h"
#include "cg_public.h"
#include "wrapper.h"
#include "main.h"


typedef int (*pdllEntry_spec)(int (__cdecl *)( int, ...));
typedef int (*pvmMain_spec)( int, int, int, int, int, int, int, int);


pdllEntry_spec pdllEntry;
pvmMain_spec pvmMain;
HMODULE hmod;
int serverCommandSequence;

void dllEntry( int (__cdecl  *syscallptr)( int arg,... ) ) {
	
	// store the syscall function pointer to a local pointer
	syscall = syscallptr;
	

	// load up the real dll
	hmod = LoadLibrary("c:\\temp\\cgamex86.dll");

	// inport the exported functions of the real dll
	pdllEntry = (pdllEntry_spec)GetProcAddress(hmod,"dllEntry");
	pvmMain = (pvmMain_spec)GetProcAddress(hmod, "vmMain");
	
	// init the real dll with our syscall wrapper function
	pdllEntry( wrapper_syscall );

}

int vmMain( int command, int arg0, int arg1, int arg2, int arg3, int arg4, int arg5, int arg6 ) {

	// return value;
	int rv;


	switch(command) {
	case CG_INIT:
		
		// pass the command onto the real dll.
		rv = pvmMain(command,arg0,arg1,arg2,arg3,arg4,arg5,arg6);
		
		// store the initial command sequence number;
		serverCommandSequence = arg1;
		// register our cvars
		RegisterCvars();
		// register our console commands
		RegisterConsoleCmd();

		break;
	case CG_DRAW_ACTIVE_FRAME:
		
		// pass the command onto the real dll.
		rv = pvmMain(command,arg0,arg1,arg2,arg3,arg4,arg5,arg6);
		
		// update our cvars
		UpdateCvars();
		if(wrap_test.integer == 1) {
			syscall(CG_PRINT,"Wrapper loaded\n");
			syscall(CG_CVAR_SET,"wrap_test","0");
		}
		break;
	case CG_CONSOLE_COMMAND:
		if(!ConsoleCommand()) {
			// if we dont see this console command in our list pass it one to the real dll
			rv = pvmMain(command,arg0,arg1,arg2,arg3,arg4,arg5,arg6);
		} else {
			// command was in our list
			rv = qtrue;
		}
		break;
	case CG_CROSSHAIR_PLAYER:
		// pass the command onto the real dll.
		rv = pvmMain(command,arg0,arg1,arg2,arg3,arg4,arg5,arg6);
		break;
	case CG_LAST_ATTACKER:
		// pass the command onto the real dll.
		rv = pvmMain(command,arg0,arg1,arg2,arg3,arg4,arg5,arg6);
		break;
	case CG_SHUTDOWN:
		// pass the command onto the real dll.
		rv = pvmMain(command,arg0,arg1,arg2,arg3,arg4,arg5,arg6);
		
		// if the command is shutdown we want to unload the real dll, if we dont
		// there will be some stale data laying around
		FreeLibrary(hmod);
		break;
	default:
		// unknown command
		// pass the command onto the real dll.
		rv = pvmMain(command,arg0,arg1,arg2,arg3,arg4,arg5,arg6);
		
		break;
	}

	// pass the return value back to quake3.exe
	return rv;

}

// this is our emulated syscall function, most calls will just be passed on
// but some we will use to intercept data for the bot.
int wrapper_syscall(int cmd, ... ) {

	
	va_list vl;
	// this will hold the return value
	int rv = 0;

	// tmp holders for args
	char *argc_ptr1;
	char *argc_ptr2;
	int *argi_ptr1;
	int *argi_ptr2;
	
	int argi1;
	int argi2;
	int argi3;
	int argi4;
	int argi5;
	int argi6;
	int argi7;
	int argi8;

	void *argv_ptr1;
	
	vmCvar_t *argCvar_ptr1;
	vec_t **argvec_ptrptr1;
	
	
	vec_t *argvec_ptr1;
	vec_t *argvec_ptr2;
	vec_t *argvec_ptr3;
	vec_t *argvec_ptr4;
	vec_t *argvec_ptr5;
	vec_t *argvec_ptr6;

	fileHandle_t *argFile_ptr;
	fileHandle_t argFile;
	clipHandle_t argclip;
	fsMode_t argfsMode;
	trace_t *argtrace_ptr;
	markFragment_t *argmark_ptr;
	qhandle_t argqhand;
	polyVert_t *argpvert_ptr;
	orientation_t *argori_ptr;
	snapshot_t *argsnap_ptr;
	usercmd_t *argucmd_ptr;
	sfxHandle_t argsfx;

	// start the va
	va_start(vl,cmd);
	
	// we have to dump the passed variables from the va list into tmp variables if the number of
	// variables is greater then 1.  this is because of the way a function is parsed by the compiler
	// syscall(blah,funtion1(),function2(),function3())  when this is parsed the order for which the
	// functions are call goes from right to left which would screw up or va_arg calls.
	switch(cmd) {
	
	case CG_PRINT:
		argc_ptr1 = va_arg(vl,char*);
		syscall(CG_PRINT,argc_ptr1);
		break;
	
    case CG_ERROR:
		syscall(CG_ERROR,va_arg(vl,char*));
		break;

	case CG_MILLISECONDS: 
		rv = syscall(CG_MILLISECONDS);
		break;

    case CG_CVAR_REGISTER:
		argCvar_ptr1 = va_arg(vl,vmCvar_t*);
		argc_ptr1 = va_arg(vl,char*);
		argc_ptr2 = va_arg(vl,char*);
		argi1 = va_arg(vl,int);
		syscall(CG_CVAR_REGISTER,argCvar_ptr1,argc_ptr1,argc_ptr2,argi1);
		break;

    case CG_CVAR_UPDATE:
		syscall(CG_CVAR_UPDATE,va_arg(vl,vmCvar_t*));
		break;

    case CG_CVAR_SET:
		argc_ptr1 = va_arg(vl,char*);
		argc_ptr2 = va_arg(vl,char*);
		syscall(CG_CVAR_SET,argc_ptr1,argc_ptr2);
		break;

    case CG_CVAR_VARIABLESTRINGBUFFER:
		argc_ptr1 = va_arg(vl,char*);
		argc_ptr2 = va_arg(vl,char*);
		argi1 = va_arg(vl,int);
		syscall(CG_CVAR_VARIABLESTRINGBUFFER,argc_ptr1,argc_ptr2,argi1);
		break;

    case CG_ARGC:
		rv = syscall(CG_ARGC);
		break;

	case CG_ARGV:
		argi1 = va_arg(vl,int);
		argc_ptr1 = va_arg(vl,char*);
		argi2 = va_arg(vl,int);
		syscall(CG_ARGV,argi1,argc_ptr1,argi2);
		break;

    case CG_ARGS:
		argc_ptr1 = va_arg(vl,char*);
		argi1 = va_arg(vl,int);
		syscall(CG_ARGS,argc_ptr1,argi1);
		break;

    case CG_FS_FOPENFILE:
		argc_ptr1 = va_arg(vl,char*);
		argFile_ptr = va_arg(vl,fileHandle_t*);
		argfsMode = va_arg(vl,fsMode_t);
		rv = syscall(CG_FS_FOPENFILE,argc_ptr1,argFile_ptr,argfsMode);
		break;

	case CG_FS_READ:
		argv_ptr1 = va_arg(vl,void*);
		argi1 = va_arg(vl,int);
		argFile = va_arg(vl,fileHandle_t);
		syscall(CG_FS_READ,argv_ptr1,argi1,argFile);
		break;

	case CG_FS_WRITE:
		argv_ptr1 = va_arg(vl,void*);
		argi1 = va_arg(vl,int);
		argFile = va_arg(vl,fileHandle_t);
		syscall(CG_FS_WRITE,argv_ptr1,argi1,argFile);
		break;

    case CG_FS_FCLOSEFILE:
		syscall(CG_FS_FCLOSEFILE,va_arg(vl,fileHandle_t));
		break;

	case CG_SENDCONSOLECOMMAND:
		syscall(CG_SENDCONSOLECOMMAND,va_arg(vl,char*));
		break;

    case CG_ADDCOMMAND:
		syscall(CG_ADDCOMMAND,va_arg(vl,char*));
		break;

    case CG_SENDCLIENTCOMMAND:
		syscall(CG_SENDCLIENTCOMMAND,va_arg(vl,char*));
		break;

	case CG_UPDATESCREEN:
		syscall(CG_UPDATESCREEN);
		break;

    case CG_CM_LOADMAP:
		syscall(CG_CM_LOADMAP,va_arg(vl,char*));
		break;

    case CG_CM_NUMINLINEMODELS:
		rv = syscall(CG_CM_NUMINLINEMODELS);
		break;

    case CG_CM_INLINEMODEL:
		rv = syscall(CG_CM_INLINEMODEL,va_arg(vl,int));
		break;

		// this one isnt defined as a trap fuction.
    case CG_CM_LOADMODEL:
		break;
		
    case CG_CM_TEMPBOXMODEL:
		argvec_ptr1 = va_arg(vl,vec_t*);
		argvec_ptr2 = va_arg(vl,vec_t*);
		rv = syscall(CG_CM_TEMPBOXMODEL,argvec_ptr1,argvec_ptr2);
		break;

    case CG_CM_POINTCONTENTS:
		argvec_ptr1 = va_arg(vl,vec_t*);
		argclip = va_arg(vl,clipHandle_t);
		rv = syscall(CG_CM_POINTCONTENTS,argvec_ptr1,argclip);
		break;

	case CG_CM_TRANSFORMEDPOINTCONTENTS:
		argvec_ptr1 = va_arg(vl,vec_t*);
		argclip = va_arg(vl,clipHandle_t);
		argvec_ptr2 = va_arg(vl,vec_t*);
		argvec_ptr3 = va_arg(vl,vec_t*);
		rv = syscall(CG_CM_TRANSFORMEDPOINTCONTENTS,argvec_ptr1,argclip,argvec_ptr2,argvec_ptr3);
		break;

	case CG_CM_BOXTRACE:
		argtrace_ptr = va_arg(vl,trace_t*);
		argvec_ptr1 = va_arg(vl,vec_t*);
		argvec_ptr2 = va_arg(vl,vec_t*);
		argvec_ptr3 = va_arg(vl,vec_t*);
		argvec_ptr4 = va_arg(vl,vec_t*);
		argclip = va_arg(vl,clipHandle_t);
		argi1 = va_arg(vl,int);
		syscall(CG_CM_BOXTRACE,argtrace_ptr,argvec_ptr1,argvec_ptr2,argvec_ptr3,argvec_ptr4,argclip,argi1);
		break;

	case CG_CM_TRANSFORMEDBOXTRACE:
		argtrace_ptr = va_arg(vl,trace_t*);
		argvec_ptr1 = va_arg(vl,vec_t*);
		argvec_ptr2 = va_arg(vl,vec_t*);
		argvec_ptr3 = va_arg(vl,vec_t*);
		argvec_ptr4 = va_arg(vl,vec_t*);
		argclip = va_arg(vl,clipHandle_t);
		argi1 = va_arg(vl,int);
		argvec_ptr5 = va_arg(vl,vec_t*);
		argvec_ptr6 = va_arg(vl,vec_t*);
		syscall(CG_CM_TRANSFORMEDBOXTRACE,argtrace_ptr,argvec_ptr1,argvec_ptr2,argvec_ptr3,argvec_ptr4,argclip,argi1,argvec_ptr5,argvec_ptr6);
		break;

	case CG_CM_MARKFRAGMENTS:
		argi1 = va_arg(vl,int);
		argvec_ptr1 = va_arg(vl,vec_t*);
		argvec_ptr2 = va_arg(vl,vec_t*);
		argi2 = va_arg(vl,int);
		argvec_ptr3 = va_arg(vl,vec_t*);
		argi3 = va_arg(vl,int);
		argmark_ptr = va_arg(vl,markFragment_t*);
		rv = syscall(CG_CM_MARKFRAGMENTS,argi1,argvec_ptr1,argvec_ptr2, argi2,argvec_ptr3,argi3,argmark_ptr);
		break;

    case CG_S_STARTSOUND:
		argvec_ptr1 = va_arg(vl,vec_t*);
		argi1 = va_arg(vl,int);
		argi2 = va_arg(vl,int);
		argsfx = va_arg(vl,sfxHandle_t);
		syscall(CG_S_STARTSOUND,argvec_ptr1,argi1,argi2,argsfx);
		break;

	case CG_S_STARTLOCALSOUND:
		argsfx = va_arg(vl,sfxHandle_t);
		argi1 = va_arg(vl,int);
		syscall(CG_S_STARTLOCALSOUND,argsfx,argi1);
		break;

	case CG_S_CLEARLOOPINGSOUNDS:
		syscall(CG_S_CLEARLOOPINGSOUNDS);
		break;

	case CG_S_ADDLOOPINGSOUND:
		argi1 = va_arg(vl,int);
		argvec_ptr1 = va_arg(vl,vec_t*);
		argvec_ptr2 = va_arg(vl,vec_t*);
        argsfx = va_arg(vl,sfxHandle_t);
		syscall(CG_S_ADDLOOPINGSOUND,argi1,argvec_ptr1,argvec_ptr2,argsfx);
		break;

	case CG_S_UPDATEENTITYPOSITION:
		argi1 = va_arg(vl,int);
		argvec_ptr1 = va_arg(vl,vec_t*);
		syscall(CG_S_UPDATEENTITYPOSITION,argi1,argvec_ptr1);
		break;

	case CG_S_RESPATIALIZE:
		argi1 = va_arg(vl,int);
		argvec_ptr1 = va_arg(vl,vec_t*);
		argvec_ptrptr1 = va_arg(vl,vec_t**);
		argi2 = va_arg(vl,int);
		syscall(CG_S_RESPATIALIZE,argi1,argvec_ptr1,argvec_ptrptr1,argi2);
		break;

	case CG_S_REGISTERSOUND:
		rv = syscall(CG_S_REGISTERSOUND,va_arg(vl,char*));
		break;

	case CG_S_STARTBACKGROUNDTRACK:
		argc_ptr1 = va_arg(vl,char*);
		argc_ptr2 = va_arg(vl,char*);
		syscall(CG_S_STARTBACKGROUNDTRACK,argc_ptr1,argc_ptr2);
		break;

	case CG_R_LOADWORLDMAP:
		syscall(CG_R_LOADWORLDMAP,va_arg(vl,char*));
		break;

	case CG_R_REGISTERMODEL:
		rv = syscall(CG_R_REGISTERMODEL,va_arg(vl,char*));
		break;

	case CG_R_REGISTERSKIN:
		rv = syscall(CG_R_REGISTERSKIN,va_arg(vl,char*));
		break;

	case CG_R_REGISTERSHADER:
		rv = syscall(CG_R_REGISTERSHADER,va_arg(vl,char*));
		break;

	case CG_R_CLEARSCENE:
		syscall(CG_R_CLEARSCENE);
		break;

	case CG_R_ADDREFENTITYTOSCENE:
		syscall(CG_R_ADDREFENTITYTOSCENE,va_arg(vl,refEntity_t*));
		break;

	case CG_R_ADDPOLYTOSCENE:
		argqhand = va_arg(vl,qhandle_t);
		argi1 = va_arg(vl,int);
		argpvert_ptr = va_arg(vl,polyVert_t*);
		syscall(CG_R_ADDPOLYTOSCENE,argqhand,argi1,argpvert_ptr);
		break;

	case CG_R_ADDLIGHTTOSCENE:
		argvec_ptr1 = va_arg(vl,vec_t*);
		argi1 = va_arg(vl,int);
		argi2 = va_arg(vl,int);
		argi3 = va_arg(vl,int);
		argi4 = va_arg(vl,int);
		syscall(CG_R_ADDLIGHTTOSCENE,argvec_ptr1,argi1,argi2,argi3,argi4);
		break;

	case CG_R_RENDERSCENE:
		syscall(CG_R_RENDERSCENE,va_arg(vl,refdef_t*));
		break;

	case CG_R_SETCOLOR:
		syscall(CG_R_SETCOLOR,va_arg(vl,float*));
		break;

	case CG_R_DRAWSTRETCHPIC:
		argi1 = va_arg(vl,int);
		argi2 = va_arg(vl,int);
		argi3 = va_arg(vl,int);
		argi4 = va_arg(vl,int);
		argi5 = va_arg(vl,int);
		argi6 = va_arg(vl,int);
		argi7 = va_arg(vl,int);
		argi8 = va_arg(vl,int);
		argqhand = va_arg(vl,qhandle_t);
		syscall(CG_R_DRAWSTRETCHPIC,argi1,argi2,argi3,argi4,argi5,argi6,argi7,argi8,argqhand);
		break;

	case CG_R_MODELBOUNDS:
		argclip= va_arg(vl,clipHandle_t);
		argvec_ptr1 = va_arg(vl,vec_t*);
		argvec_ptr2 = va_arg(vl,vec_t*);
		syscall(CG_R_MODELBOUNDS,argclip,argvec_ptr1,argvec_ptr2);
		break;

	case CG_R_LERPTAG:
		argori_ptr = va_arg(vl,orientation_t*);
		argclip = va_arg(vl,clipHandle_t);
		argi1 = va_arg(vl,int);
		argi2 = va_arg(vl,int);
		argi3 = va_arg(vl,int);
		argc_ptr1 = va_arg(vl,char*);
		syscall(CG_R_LERPTAG,argori_ptr,argclip,argi1,argi2,argi3,argc_ptr1);
		break;

	case CG_GETGLCONFIG:
		syscall(CG_GETGLCONFIG,va_arg(vl,glconfig_t *));
		break;

	case CG_GETGAMESTATE:
		syscall(CG_GETGAMESTATE,va_arg(vl,gameState_t *));
		break;

	case CG_GETCURRENTSNAPSHOTNUMBER:
		argi_ptr1 = va_arg(vl,int*);
		argi_ptr2 = va_arg(vl,int*);
		syscall(CG_GETCURRENTSNAPSHOTNUMBER,argi_ptr1, argi_ptr2);
		break;

	case CG_GETSNAPSHOT:
		argi1 = va_arg(vl,int);
		argsnap_ptr = va_arg(vl,snapshot_t*);
		rv = syscall(CG_GETSNAPSHOT,argi1,argsnap_ptr);
		break;

	case CG_GETSERVERCOMMAND:
		rv = syscall(CG_GETSERVERCOMMAND,va_arg(vl,int));
		break;

	case CG_GETCURRENTCMDNUMBER:
		rv = syscall(CG_GETCURRENTCMDNUMBER);
		break;

	case CG_GETUSERCMD:
		argi1 = va_arg(vl,int);
		argucmd_ptr = va_arg(vl,usercmd_t*);
		rv = syscall(CG_GETUSERCMD,argi1,argucmd_ptr);
		break;

	case CG_SETUSERCMDVALUE:
		argi1 = va_arg(vl,int);
		argi2 = va_arg(vl,int);
		syscall(CG_SETUSERCMDVALUE,argi1,argi2);
		break;

	case CG_R_REGISTERSHADERNOMIP:
		rv = syscall(CG_R_REGISTERSHADERNOMIP,va_arg(vl,char*));
		break;

	case CG_MEMORY_REMAINING:
		rv = syscall(CG_MEMORY_REMAINING);
		break;

     /*   
        CG_MEMSET = 100,
        CG_MEMCPY,
        CG_STRNCPY,
        CG_SIN,
        CG_COS,
        CG_ATAN2,
        CG_SQRT,
        CG_FLOOR,
        CG_CEIL, 
       */ 
	case CG_TESTPRINTINT:
		argc_ptr1 = va_arg(vl,char*);
		argi1 = va_arg(vl,int);
		syscall(CG_TESTPRINTINT,argc_ptr1,argi1);
		break;
	case CG_TESTPRINTFLOAT: 
		argc_ptr1 = va_arg(vl,char*);
		argi1 = va_arg(vl,int);
		syscall(CG_TESTPRINTFLOAT,argc_ptr1,argi1);
		break;
	default:
		// unknown command was passed back to syscall, dump it to a console print
		syscall(CG_PRINT,"Unknown cmd: %d\n",cmd);
		break;
	}

	// stop the va and return
	va_end(vl);
	return rv;
}